_, class = UnitClass("player")
if class == "MONK" then

local ADDON_NAME, namespace = ...
local L = namespace.L

MHStaggerID = {
["light stagger"] = 124275,
["moderate stagger"] = 124274,
["heavy stagger"] = 124273,
}

function MonkHelper_UpdateStaggerTracker()
local staggeramount

if UnitDebuff("player", GetSpellInfo(MHStaggerID["light stagger"])) then
staggeramount = select(16, UnitDebuff("player", GetSpellInfo(MHStaggerID["light stagger"])))
elseif UnitDebuff("player", GetSpellInfo(MHStaggerID["moderate stagger"])) then
staggeramount = select(16, UnitDebuff("player", GetSpellInfo(MHStaggerID["moderate stagger"])))
elseif UnitDebuff("player", GetSpellInfo(MHStaggerID["heavy stagger"])) then
staggeramount = select(16, UnitDebuff("player", GetSpellInfo(MHStaggerID["heavy stagger"])))
end
if staggeramount == nil then staggeramount = 0 end
local health = UnitHealthMax("player")
local hp = UnitHealth("player")
local hppercent = MonkHelper_ShortNumber(hp/health)
if hp == nil then hp = 0 end
if hppercent == nil then hppercent = 0 end
if staggeramount/health >= 0.60 then
MHStaggerTrackerIcon:SetTexture("Interface\\Icons\\priest_icon_chakra_red")
elseif staggeramount/health >= 0.30 then
MHStaggerTrackerIcon:SetTexture("Interface\\Icons\\priest_icon_chakra_green")
else
MHStaggerTrackerIcon:SetTexture("Interface\\Icons\\priest_icon_chakra")
end
local staggerpercent
staggerpercent = staggeramount / health
if staggerpercent > 0.001 then
staggerpercent = MonkHelper_ShortNumber(staggerpercent)
elseif staggerpercent ~= 0 then
staggerpercent = 0.1
end
if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggerpercent == 1 and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggernumber == 0 then
MHStaggerTrackerText:SetText(staggerpercent.."%")
elseif MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggerpercent == 0 and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggernumber == 1 then
MHStaggerTrackerText:SetText(MonkHelper_CondenseNumber(staggeramount))
elseif MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggerpercent == 1 and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggernumber == 1 then
MHStaggerTrackerText:SetText(MonkHelper_CondenseNumber(staggeramount).."("..staggerpercent.."%)")
else
MHStaggerTrackerText:SetText("")
end

end

function MonkHelper_CreateTrackersUI()
local backdrop = {edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12}
local backdropthick = {edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", edgeSize = 12}

-- Create Stagger Tracker
CreateFrame("Frame", "MHStaggerTracker", UIParent)

MHStaggerTracker:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16)
if MHtimerbypass == 0 and self:IsShown() then

if event == "UNIT_AURA" and arg1 == "player" then
MonkHelper_UpdateStaggerTracker()
elseif event == "UNIT_HEALTH_FREQUENT" and arg1 == "player" then
MonkHelper_UpdateStaggerTracker()
end

end
end)

MHStaggerTracker:RegisterEvent("UNIT_AURA")
MHStaggerTracker:RegisterEvent("UNIT_HEALTH_FREQUENT")

MHStaggerTracker:SetPoint("CENTER")
MHStaggerTracker:SetWidth(28)
MHStaggerTracker:SetHeight(28)
MHStaggerTracker:CreateTexture("$parentIcon")
MHStaggerTrackerIcon:SetTexture("Interface\\Icons\\priest_icon_chakra")
MHStaggerTrackerIcon:SetWidth(28)
MHStaggerTrackerIcon:SetHeight(28)
MHStaggerTrackerIcon:SetPoint("CENTER", MHStaggerTracker, "CENTER")
MHStaggerTracker:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
MHStaggerTrackerText:SetPoint("LEFT", MHStaggerTracker, "RIGHT", 5, 0)
MHStaggerTrackerText:SetTextColor(1, 1, 1)
MHStaggerTrackerText:SetJustifyH("LEFT")
MHStaggerTrackerText:SetText("")

MonkHelper_SetupFrame(MHStaggerTracker)

end

function MonkHelper_CreateTrackersOptionsMenu()

--Trackers---------------------------------------------------------------
MonkHelper.trackers = CreateFrame("Frame", "MHTrackersOptions", MHOptionsFrame)
MonkHelper.trackers:SetWidth(625)
MonkHelper.trackers:SetHeight(570)
MonkHelper.trackers:SetPoint("LEFT", MHOptionsFrameButtons, "RIGHT", 5, 0)
MonkHelper.trackers.name = L["TRACKERS"]
MonkHelper.trackers:SetFrameLevel(4)

MHTrackersScrollFrame = CreateFrame("ScrollFrame", "MHTrackersScrollFrame", MonkHelper.trackers)
MHTrackersScrollFrame:SetPoint("TOPLEFT", 10, -10) 
MHTrackersScrollFrame:SetPoint("BOTTOMRIGHT", -15, 15) 

MHTrackersContent = CreateFrame("Frame", "MHTrackersContent", MHTrackersScrollFrame)
MHTrackersContent:SetPoint("CENTER")
MHTrackersContent:SetWidth(580)
MHTrackersContent:SetHeight(4000)
MHTrackersScrollFrame:SetScrollChild(MHTrackersContent)

MHTrackersScroll = CreateFrame("Slider", "MHTrackersScroll", MHTrackersScrollFrame, "UIPanelScrollBarTemplate")
MHTrackersScroll:CreateTexture("$parentBG")
MHTrackersScrollBG:SetWidth(16)
MHTrackersScrollBG:SetHeight(445)
MHTrackersScrollBG:SetPoint("CENTER", -0.5, 0)
MHTrackersScrollBG:SetTexture(0.2, 0.2, 0.2, 0.5)
MHTrackersScroll:SetOrientation("VERTICAL")
MHTrackersScroll:SetWidth(20)
MHTrackersScroll:SetHeight(450)
MHTrackersScroll:SetPoint("RIGHT", MonkHelper.trackers, "RIGHT", -5, 0)
MHTrackersScroll:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
MHTrackersScroll:SetValueStep(20)
MHTrackersScroll:SetValue(0)
MHTrackersContent:SetScript("OnMouseWheel", function(self, delta)
local scroll = MHTrackersScroll:GetValue()
if delta > 0  then
MHTrackersScroll:SetValue(scroll - MHTrackersScroll:GetValueStep())
elseif delta < 0 then
MHTrackersScroll:SetValue(scroll + MHTrackersScroll:GetValueStep())
end
end)

x = 50
y = 0
local spacey, scaley = 60, 50

y = y - 20
CreateFrame("CheckButton", "MHStaggerTrackerShow", MHTrackersContent, "ChatConfigCheckButtonTemplate")
MHStaggerTrackerShow:SetPoint("TOPLEFT", MHTrackersContent, "TOPLEFT", x, y)
MHStaggerTrackerShowText:SetText(L["STAGGER"].." "..L["TRACKER"])
MHStaggerTrackerShow:SetChecked(MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhstaggertracker)
MHStaggerTrackerShow:CreateTexture("$parentIcon")
MHStaggerTrackerShowIcon:SetTexture("Interface\\Icons\\priest_icon_chakra")
MHStaggerTrackerShowIcon:SetWidth(32)
MHStaggerTrackerShowIcon:SetHeight(32)
MHStaggerTrackerShowIcon:SetPoint("TOPLEFT", MHTrackersContent, "TOPLEFT", x - 41, y + 4)

y = y - 20
CreateFrame("CheckButton", "MHStaggerTrackerNumberShow", MHTrackersContent, "ChatConfigCheckButtonTemplate")
MHStaggerTrackerNumberShow:SetPoint("TOPLEFT", MHTrackersContent, "TOPLEFT", x, y)
MHStaggerTrackerNumberShowText:SetText(L["STAGGER_TRACKER_NUMBER"])
MHStaggerTrackerNumberShow:SetChecked(MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggernumber)

y = y - 20
CreateFrame("CheckButton", "MHStaggerTrackerPercentShow", MHTrackersContent, "ChatConfigCheckButtonTemplate")
MHStaggerTrackerPercentShow:SetPoint("TOPLEFT", MHTrackersContent, "TOPLEFT", x, y)
MHStaggerTrackerPercentShowText:SetText(L["STAGGER_TRACKER_PERCENT"])
MHStaggerTrackerPercentShow:SetChecked(MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.staggerpercent)

y = y - scaley
CreateFrame("Slider","MHStaggerTrackerScale", MHTrackersContent)
MHStaggerTrackerScale:SetPoint("TOPLEFT", MHTrackersContent, "TOPLEFT", x, y)
MHStaggerTrackerScale:SetWidth(300)
MHStaggerTrackerScale:SetHeight(20)
MHStaggerTrackerScale:SetOrientation("HORIZONTAL")
MHStaggerTrackerScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MHStaggerTrackerScale:SetMinMaxValues(0.5,2)
MHStaggerTrackerScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MHStaggerTrackerScale:SetScript("OnValueChanged", function (self, value) MHStaggerTrackerScaleValue:SetText(string.sub(value, 1, 4)) MHStaggerTracker:SetScale(value) end)
MHStaggerTrackerScaleHeader = MHTrackersContent:CreateFontString("MHStaggerTrackerScaleHeader", "OVERLAY", "GameFontNormal")
MHStaggerTrackerScaleHeader:SetPoint("BOTTOMLEFT", MHStaggerTrackerScale, "TOPLEFT")
MHStaggerTrackerScaleHeader:SetText(L["SCALE"])
MHStaggerTrackerScaleValue = MHTrackersContent:CreateFontString("MHStaggerTrackerScaleValue", "OVERLAY", "GameFontNormal")
MHStaggerTrackerScaleValue:SetPoint("BOTTOMRIGHT", MHStaggerTrackerScale, "TOPRIGHT")
MHStaggerTrackerScaleValue:SetText(string.sub(MonkHelper_Profiles[MonkHelper_ActiveProfile].options.scale.mhstaggertracker, 1, 4))

MonkHelper.trackers:Hide()
--------------------------------------------------------------------------------------------------------------
MHTrackersScroll:SetMinMaxValues(0, (abs(y)/60)*40)
MHTrackersScroll:SetValue(0)
--------------------------------------------------------------------------------------------

end


end